package com.mokabyte.mokabook.javaBeans.timer;

import com.mokabyte.mokabook.javaBeans.*;
import java.io.*;
import java.util.*;

public class TimerBean implements Serializable {

private int time = 1000;
private transient TimerThread timerThread;
private Vector timerListeners = new Vector();

public void addTimerListener(TimerListener t) {
  timerListeners.add(t);
}
public void removeTimerListener(TimerListener t) {
  timerListeners.remove(t);
}
public synchronized void setMillis(int millis) {
  time = millis;
}
public synchronized int getMillis() {
  return time; 
}
public synchronized void startTimer() {
  if(timerThread!=null)
    forceTick();
  timerThread = new TimerThread();
  timerThread.start();
}
public synchronized void stopTimer() {
  if(timerThread==null)
    return;
 
  timerThread.killTimer();
  timerThread = null;
}
public synchronized void forceTick() {
  if(timerThread!=null) {
    stopTimer();
    startTimer();
  }
  else
    fireTimerEvent(new TimerEvent(this));
}
protected void fireTimerEvent(TimerEvent e) {
  Enumeration listeners = timerListeners.elements();
  while(listeners.hasMoreElements())
    ((TimerListener)listeners.nextElement()).clockTicked(e);
}

  class TimerThread extends Thread {
    private boolean running = true;

    public synchronized void killTimer() {
      running = false;
    }
    private synchronized boolean isRunning() {
      return running;
    }
    public void run() {
      while(true)
        try {
          if(isRunning()) {
            fireTimerEvent(new TimerEvent(TimerBean.this));
            Thread.sleep(getMillis());
          }
          else
            break;
      }
      catch(InterruptedException e) {}
    }
  }
}